% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function [ hv ] = get_hypervolume(obj1_list, obj2_list, max_obj1, min_obj2)

    [obj1_list_pareto,obj2_list_pareto,tmp_rest_list] = order_pareto(obj1_list,obj2_list,zeros(length(obj1_list),1));
    [obj1_list_pareto,obj2_list_pareto] = get_pareto_set_to_plot(obj1_list_pareto,obj2_list_pareto);
       
    min_pareto_obj1 = obj1_list_pareto(1);
    max_pareto_obj2 = obj2_list_pareto(length(obj2_list_pareto));

    obj1_polygon = [obj1_list_pareto;max_obj1;max_obj1;min_pareto_obj1;obj1_list_pareto(1)];
    obj2_polygon = [obj2_list_pareto;max_pareto_obj2;min_obj2;min_obj2;obj2_list_pareto(1)];

    hv = polyarea(obj1_polygon,obj2_polygon);

end

