% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function [ pareto_a_o,pareto_t_o, pareto_r_o ] = get_pareto( area, thrput, rest )
%This function inputs two vectors: area and thro
%it finds the Pareto set given that 
%area is to be minimized and thro is to be maximized.
%Outputs 2 vectors: area and thro of Pareto points.
%The output is ordered from small to big in the x axis (area)

       pareto_a = 0;
       pareto_t = 0;
       pareto_r = 0;

        for ind=1:length(thrput)
                pareto = true;
                
                for j=1:length(area)
                        if (j==ind)
                                continue
                        end
                        %if (greater_than(thrput(j),thrput(ind)) && less_than(area(j),area(ind)))
                        
                        tmp1 = greater_than(thrput(j),thrput(ind)) && less_than(area(j),area(ind));
                        tmp2 = equal_to(thrput(j),thrput(ind)) && less_than(area(j),area(ind));
                        tmp3 = greater_than(thrput(j),thrput(ind)) && equal_to(area(j),area(ind));
                        
                        if (tmp1 || tmp2 || tmp3)
                        
                        %if ((thrput(j)>thrput(ind) & area(j)<area(ind)) | (thrput(j)==thrput(ind) & area(j)<area(ind)) | (thrput(j)>thrput(ind) & area(j)==area(ind)))

                                pareto = false;
         
                                break
                        end
                end
                if (pareto)

                        if (pareto_t==0)
                            pareto_t = [thrput(ind)];
                            pareto_a = [area(ind)];
                            pareto_r = [rest(ind)];
                        else
                            pareto_t = [pareto_t;thrput(ind)];
                            pareto_a = [pareto_a;area(ind)];
                            pareto_r = [pareto_r;rest(ind)];
                        end
%                         ind
%                         thrput(ind)
%                         area(ind)
%                         pause
                     
                end
        end
                   

        [pareto_a_o,pareto_t_o,pareto_r_o] = order_pareto(pareto_a,pareto_t,pareto_r);

end


