% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function pareto_01list  = get_pareto_01list(obj1, obj2)

pareto_01list = ones(length(obj1),1);
max_thrput = 0;
%sort in one dimension
[sorted_obj1,sorted_obj1_ind]=sort(obj1);

%check second dimension
for i=1:length(sorted_obj1_ind)
    ind = sorted_obj1_ind(i);
   if max_thrput >= obj2(ind)
       pareto_01list(ind) = 0;
   else 
       max_thrput = obj2(ind);
   end
end

end


