% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function avg_error = get_prediction_avg_error_pareto( response_test, response_predicted, pareto_01list, log_train)
%This function calculates the error given the prediction and the test data

	accum = 0;
	count = 0;
    
    if log_train == 0
        
        tmp_tree = abs(((response_test-response_predicted)./response_test).*100);
        for i = 1:length(pareto_01list)
            if pareto_01list(i)==1
                count = count + 1;
                accum = accum + tmp_tree(i);
            end
        end
    else
        for i = 1:length(pareto_01list)

            if pareto_01list(i)==1
                
                tmp_tree = abs(1-2^(abs(response_test(i)-response_predicted(i))))*100;

                count = count + 1;
                accum = accum + tmp_tree;
                
            end
        end
    end
	
    avg_error = accum/count; 
    
end

