% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function data_array = get_start_samples(data_array,length_training_start,num_features)
    
    % random permutation
    data_array = data_array(randsample(1:length(data_array),length(data_array)),:);

    %cluster data in length_training_start clusters
    
    features=data_array(:,1:num_features);
    lin = linkage(features,'average','euclidean');
    

    c = cluster(lin,'maxclust',length_training_start);
    training_data=-1;
    rest_data=-1;

    next_samples=[];
    rest_data=[];
    
    for i =1:length_training_start
        tmp_array=[];
        tmp_index_array=[];
        for j=1:length(c)
            if c(j)==i
                tmp_array=[tmp_array;features(j,:)];
                tmp_index_array=[tmp_index_array;j];
            end
        end
        
        size_tmp_array=size(tmp_array);
        len_tmp_array=size_tmp_array(1);
        
        if len_tmp_array==1
            tmp_mean = tmp_array;

        else
            tmp_mean = mean(tmp_array);
        end
            %find point closest to mean
        
        
        
	% just measures euclidean distance
        min_dist = pdist([tmp_array(1,:);tmp_mean]);
 
        for p =1:len_tmp_array
            tmp_val = pdist([tmp_mean;tmp_array(p,:)]);
            if (tmp_val<=min_dist)
                min_dist = tmp_val;
                next_sample = data_array(tmp_index_array(p),:);
                tmp_index=p;
            end
        end
        for p =1:len_tmp_array
            if p==tmp_index
                continue
            else
                rest_data=[rest_data;data_array(tmp_index_array(p),:);];
            end
        end
        
        
        next_samples = [next_samples;next_sample]; 
    end
   
    data_array = [next_samples;rest_data];
    

     
end
