% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function plot_gp_predictions(real_obj1,real_obj2,prediction_obj1,prediction_obj2,s_obj1,s_obj2,beta,real_pareto_01list,one_not_p,one_is_pareto)                           
    figure()
    hold on       
                            
    for i = 1:length(real_obj1)
	u_a=prediction_obj1(i);
        u_t=prediction_obj2(i);
        s_a = s_obj1(i);
        s_t = s_obj2(i);

        obj1_vector = [u_a+beta*s_a,u_a+beta*s_a,u_a-beta*s_a,u_a-beta*s_a,u_a+beta*s_a];
        obj2_vector = [u_t+beta*s_t,u_t-beta*s_t,u_t-beta*s_t,u_t+beta*s_t,u_t+beta*s_t]; 
                                  
        if (one_not_p(i))
        	if (real_pareto_01list(i))
                	line(obj1_vector,obj2_vector,'Color','b','LineStyle','--');
                else
                        line(obj1_vector,obj2_vector,'Color','b','LineStyle','-');
                end
        else
                if (one_is_pareto(i))
                	if (real_pareto_01list(i))
                        	line(obj1_vector,obj2_vector,'Color','g','LineStyle','--');
                        else
                                line(obj1_vector,obj2_vector,'Color','g','LineStyle','-');
                        end

                else
                        if (real_pareto_01list(i))
                                line(obj1_vector,obj2_vector,'Color','k','LineStyle','--');
                        else
                                line(obj1_vector,obj2_vector,'Color','k','LineStyle','-');
                        end
                end
         end
     end
                            
     for i = 1:length(real_obj1)
     	u_a=prediction_obj1(i);
        u_t=prediction_obj2(i);
        s_a = s_obj1(i);
        s_t = s_obj2(i);

        if (one_not_p(i))
        	scatter(u_a, u_t, 'MarkerFaceColor','b','MarkerEdgeColor','b');
        else 
                if (one_is_pareto(i))
                	scatter(u_a, u_t,'MarkerFaceColor','g','MarkerEdgeColor','g');
                else
                        scatter(u_a, u_t, 'MarkerFaceColor','k','MarkerEdgeColor','k');
                end
        end                    
        line([u_a,(real_obj1(i))],[u_t, (real_obj2(i))],'Color','y');
        scatter((real_obj1(i)),(real_obj2(i)),'MarkerEdgeColor','r');
    end
end
