% PAL (Pareto Active Learning) Algorithm 
%
% Copyright (c) 2013 ETH Zurich
% 
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function [response_tree, variance_per_response] = tree_prediction( features_train, response_train, features_test, response_test )
%This function creates a decision tree with the train data and test it on
%test data to return the average prediction error
    tree = classregtree(features_train,response_train);
    [response_tree,response_nodes] = eval(tree,features_test);
    tmp_tree = abs(((response_test-response_tree)./response_test).*100);
    avg_error_tree = mean(tmp_tree);
    
    [subst_response,subst_nodes] = eval(tree,features_train);
    size_node_tree = nodesize(tree);
    variance_per_node = zeros(numnodes(tree),1);
    if (length(subst_nodes)>1)
        for node_i=1:numnodes(tree),
        data_tmp = 0;
        dimen = size(features_train);
        for sample_j=1:dimen(1),
            if (subst_nodes(sample_j)==node_i)
                if (data_tmp==0)
                    data_tmp = [response_train(sample_j)];
                else
                    data_tmp = [data_tmp,response_train(sample_j)];
                end
            end
        end

        variance_per_node(node_i) = var(data_tmp);
        end
    end

    variance_per_response = zeros(length(features_test),1);
    for sample_j=1:length(features_test)
        variance_per_response(sample_j) = variance_per_node(response_nodes(sample_j));
    end;
    %variance_per_response
        
end

